library ieee;
use ieee.std_logic_1164.all;

library ADC_components;
use ADC_components.components.all;

entity TOP is
  port (
    clka  : in  std_logic;
    addra : in  std_logic_vector(5 downto 0);
    dataa : in  std_logic_vector(7 downto 0);
    qa    : out std_logic_vector(7 downto 0);
    
    clkb  : in  std_logic;
    addrb : in  std_logic_vector(5 downto 0);
    datab : in  std_logic_vector(7 downto 0);
    qb    : out std_logic_vector(7 downto 0)
  );
end entity TOP;

architecture RTL of TOP is

  signal addra_int : std_logic_vector(5 downto 0);
  signal dataa_int : std_logic_vector(7 downto 0);
  signal qa_int    : std_logic_vector(7 downto 0);
    
  signal addrb_int : std_logic_vector(5 downto 0);
  signal datab_int : std_logic_vector(7 downto 0);
  signal qb_int    : std_logic_vector(7 downto 0);

begin

  process (clka) is
  begin
    if (clka'event and clka = '1') then
      addrb_int <= addrb;
      datab_int <= datab;
      qb <= qb_int;
    end if;
  end process;
  
  process (clkb) is
  begin
    if (clkb'event and clkb = '1') then
      addra_int <= addra;
      dataa_int <= dataa;
      qa <= qa_int;
    end if;
  end process;

  uRAM: RAM
    port map (
      clka  => clka,
      addra  => addra_int,
      dataa => dataa_int,
      qa    => qa_int,
      
      clkb  => clkb,
      addrb  => addrb_int,
      datab => datab_int,
      qb    => qb_int
    );

end architecture RTL;
