library ieee;
use ieee.std_logic_1164.all;

library ADC_components;
use ADC_components.components.all;

entity TOP is
	port (
		clk:  in  std_logic;
		rsta: in  std_logic;
		rstb: in  std_logic;
		data: in  std_logic_vector(7 downto 0);
		qb:   out std_logic_vector(7 downto 0)
	);
end entity TOP;

architecture RTL of TOP is

  signal qa   : std_logic_vector(7 downto 0);
  signal clka : std_logic;
  signal clkb : std_logic;

begin

  uCLK_GEN: CLK_GEN_UNCONSTRAINED
    generic map (
      DIVA => 2,
      DIVB => 7
    )
    port map (
      CLK => CLK,
      CLK_OUT => open,
      CLK_OUT_DIVA => clka,
      CLK_OUT_DIVB => clkb
    );

  uFFA: FDR
    port map (
      clk => clka,
      rst => rsta,
      data => data,
      q => qa
    );

  uFFB: FDR
    port map (
      clk => clkb,
      rst => rstb,
      data => not qa,
      q => qb
    );

end architecture RTL;
